function varargout = demo1(varargin)
% DEMO1 M-file for demo1.fig
%      DEMO1 - ilustrates the parameters of forward and inverse waves
%      A exp(-alpha x) * sin (omega t - beta x + psi0)
%      A exp(-alpha x) * sin (omega t + beta x + psi0)
%      A exp(-alpha x) * cos (omega t - beta x + psi0)
%      A exp(-alpha x) * cos (omega t + beta x + psi0)
%
% Code by Gabriela Ciuprina 
% gabriela@lmn.pub.ro
% www.lmn.pub.ro/~gabriela
% Last update by GC - 8 March 2008
%
% Last Modified by GUIDE v2.5 23-Feb-2008 09:20:26

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @demo1_OpeningFcn, ...
    'gui_OutputFcn',  @demo1_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo1 is made visible.
function demo1_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo1 (see VARARGIN)

% Choose default command line output for demo1
handles.parameters.index_function = 1;
handles.parameters.A = 1;
handles.parameters.alpha = 0.1;
handles.parameters.beta = 0.5;
handles.parameters.psi0 = 0;
handles.parameters.omega = 1e8;
handles.parameters.no_per_x = 4;
handles.parameters.no_per_t = 4;
handles.parameters.no_pct = 100;
handles.parameters.x0 = 0;
handles.parameters.t0 = 0;
[handles] = compute_and_draw(handles);
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo1 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo1_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on selection change in popupmenu_choose_function.
function popupmenu_choose_function_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_choose_function (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu_choose_function contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_choose_function
handles.parameters.index_function = get(hObject,'Value');
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
% handles.parameters
%disp('ChooseIntegrand_Callback - End')

% --- Executes during object creation, after setting all properties.
function popupmenu_choose_function_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_choose_function (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_A_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_A (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_A as text
%        str2double(get(hObject,'String')) returns contents of edit_text_A as a double
handles.parameters.A = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_A_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_A (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_alpha_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_alpha as text
%        str2double(get(hObject,'String')) returns contents of edit_text_alpha as a double
handles.parameters.alpha = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_alpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_alpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_omega_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_omega (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_omega as text
%        str2double(get(hObject,'String')) returns contents of edit_text_omega as a double
handles.parameters.omega = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data

%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_omega_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_omega (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_beta_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_beta as text
%        str2double(get(hObject,'String')) returns contents of edit_text_beta as a double
handles.parameters.beta = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_beta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_psi0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_psi0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_psi0 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_psi0 as a double
handles.parameters.psi0 = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_psi0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_psi0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushb_animatie.
function pushb_animatie_Callback(hObject, eventdata, handles)
% hObject    handle to pushb_animatie (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
axes(handles.axes_animatie);
vector_t = linspace(handles.parameters.t0,...
    handles.parameters.t0+handles.parameters.no_per_t*handles.parameters.T,...
    handles.parameters.no_pct);
vector_x = linspace(handles.parameters.x0,...
    handles.parameters.x0+handles.parameters.no_per_x*handles.parameters.lambda,...
    handles.parameters.no_pct);
minx = min(vector_x);
maxx = max(vector_x);
for k = 1:length(vector_t)
    [val] = functii(handles.parameters.index_function,...
        handles.parameters.A,...
        handles.parameters.alpha,...
        vector_x,...
        handles.parameters.omega,...
        vector_t(k),...
        handles.parameters.beta,...
        handles.parameters.psi0);
    plot(vector_x,val);
    if k == 1
        valmin = min(min(val),-max(val));
        valmax = max(-min(val),max(val));
        axis([minx maxx,valmin,valmax]);
    else
        axis([minx maxx,valmin,valmax]);
    end
    grid on;
    xlabel('x [m]');
    drawnow
end



function edit_text_x0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_x0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_x0 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_x0 as a double
handles.parameters.x0 = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_x0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_x0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_t0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_t0 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_t0 as a double
handles.parameters.t0 = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_t0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_no_per_x_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_no_per_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_no_per_x as text
%        str2double(get(hObject,'String')) returns contents of edit_text_no_per_x as a double
handles.parameters.no_per_x = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_no_per_x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_no_per_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_no_per_t_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_no_per_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_no_per_t as text
%        str2double(get(hObject,'String')) returns contents of edit_text_no_per_t as a double
handles.parameters.no_per_t = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_no_per_t_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_no_per_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_no_pct_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_no_pct (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_no_pct as text
%        str2double(get(hObject,'String')) returns contents of edit_text_no_pct as a double
handles.parameters.no_pct = str2double(get(hObject,'String'));
[handles] = compute_and_draw(handles);
guidata(hObject,handles); % Save the handles structure after adding data
%handles.parameters

% --- Executes during object creation, after setting all properties.
function edit_text_no_pct_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_no_pct (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_lambda.
function listbox_lambda_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_lambda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_lambda contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_lambda


% --- Executes during object creation, after setting all properties.
function listbox_lambda_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_lambda (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_T.
function listbox_T_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_T (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_T contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_T


% --- Executes during object creation, after setting all properties.
function listbox_T_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_T (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_v.
function listbox_v_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_v (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_v contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_v


% --- Executes during object creation, after setting all properties.
function listbox_v_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_v (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function [handles] = compute_and_draw(handles)
% calcul lambda, T, v
handles.parameters.lambda = 2*pi/handles.parameters.beta;
set(handles.listbox_lambda,'String',num2str(handles.parameters.lambda));
handles.parameters.T = 2*pi/handles.parameters.omega;
set(handles.listbox_T,'String',num2str(handles.parameters.T));
handles.parameters.v = handles.parameters.omega/handles.parameters.beta;
set(handles.listbox_v,'String',num2str(handles.parameters.v));
draw_fdex(handles);
draw_fdet(handles)
axes(handles.axes_animatie); cla;

function draw_fdex(handles)
axes(handles.axes_fdex);
vector_x = linspace(handles.parameters.x0,...
    handles.parameters.x0+handles.parameters.no_per_x*handles.parameters.lambda,...
    handles.parameters.no_pct);
minx = min(vector_x);
maxx = max(vector_x);
[val] = functii(handles.parameters.index_function,...
    handles.parameters.A,...
    handles.parameters.alpha,...
    vector_x,...
    handles.parameters.omega,...
    handles.parameters.t0,...
    handles.parameters.beta,...
    handles.parameters.psi0);
plot(vector_x,val);
% axis([minx maxx,...
%     -handles.parameters.A,handles.parameters.A]);
axis([minx maxx,...
    min(val),max(val)]);
grid on;
xlabel('x [m]');
ylabel(strcat('f(x,',num2str(handles.parameters.t0),')'));

function draw_fdet(handles)
axes(handles.axes_fdet);
vector_t = linspace(handles.parameters.t0,...
    handles.parameters.t0+handles.parameters.no_per_t*handles.parameters.T,...
    handles.parameters.no_pct);
mint = min(vector_t);
maxt = max(vector_t);
[val] = functii(handles.parameters.index_function,...
    handles.parameters.A,...
    handles.parameters.alpha,...
    handles.parameters.x0,...
    handles.parameters.omega,...
    vector_t,...
    handles.parameters.beta,...
    handles.parameters.psi0);
plot(vector_t,val);
axis([mint maxt,...
    -handles.parameters.A,handles.parameters.A]);
grid on;
xlabel('t [s]');
ylabel(strcat('f(',num2str(handles.parameters.x0),',t)'));

function [val] = functii(idx_fct,A,alpha,x,omega,t,beta,psi0)
switch idx_fct
    case 1
        val = A*exp(-alpha*x).*sin(omega*t-beta*x+psi0);
    case 2
        val = A*exp(alpha*x).*sin(omega*t+beta*x+psi0);
    case 3
        val = A*exp(-alpha*x).*cos(omega*t-beta*x+psi0);
    case 4
        val = A*exp(alpha*x).*cos(omega*t+beta*x+psi0);
    otherwise
        error('functii.m - wrong idx_fct parameter');
end