function varargout = demo3(varargin)
% DEMO3 M-file for demo3.fig
%      DEMO3 - ilustrates the reflection and the transmision of a 
% wave plane at normal incidence

% Code by Gabriela Ciuprina 
% gabriela@lmn.pub.ro
% www.lmn.pub.ro/~gabriela
% Last update by GC - 07 April 2008
%


% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @demo3_OpeningFcn, ...
                   'gui_OutputFcn',  @demo3_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo3 is made visible.
function demo3_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo3 (see VARARGIN)

% Choose default command line output for demo3

handles.parameters.f = 1e8;
handles.parameters.eps_r_1 = 1;
handles.parameters.mu_r_1 = 1;
handles.parameters.sigma_1 = 1e-3;
handles.parameters.eps_r_2 = 1;
handles.parameters.mu_r_2 = 1;
handles.parameters.sigma_2 = 1e-3;

handles.parameters.Ed1_0 = 30;
handles.parameters.psi_d1_0 = 0;
handles.parameters.t0 = 0;
handles.parameters.nr_per_timp = 4;
handles.parameters.nr_per_spatiu = 4;
handles.parameters.nr_pct = 100;
handles = TEM_1_2(handles);

handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo3 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo3_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit_text_f_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_f as text
%        str2double(get(hObject,'String')) returns contents of edit_text_f as a double
handles.parameters.f = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
handles.output = hObject;
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_f_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_eps_r_1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_eps_r_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_eps_r_1 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_eps_r_1 as a double
handles.parameters.eps_r_1 = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
handles.output = hObject;
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_eps_r_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_eps_r_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_mu_r_1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_mu_r_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_mu_r_1 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_mu_r_1 as a double
handles.parameters.mu_r_1 = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_mu_r_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_mu_r_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_sigma_1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_sigma_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_sigma_1 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_sigma_1 as a double
handles.parameters.sigma_1 = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_sigma_1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_sigma_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_eps_r_2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_eps_r_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_eps_r_2 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_eps_r_2 as a double
handles.parameters.eps_r_2 = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_eps_r_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_eps_r_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_mu_r_2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_mu_r_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_mu_r_2 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_mu_r_2 as a double
handles.parameters.mu_r_2 = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_mu_r_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_mu_r_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_sigma_2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_sigma_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_sigma_2 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_sigma_2 as a double
handles.parameters.sigma_2 = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_sigma_2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_sigma_2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_Ed1_0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_Ed1_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_Ed1_0 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_Ed1_0 as a double
handles.parameters.Ed1_0= str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_Ed1_0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_Ed1_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_psi_d1_0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_psi_d1_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_psi_d1_0 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_psi_d1_0 as a double
handles.parameters.psi_d1_0= str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_psi_d1_0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_psi_d1_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_t0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_t0 as text
%        str2double(get(hObject,'String')) returns contents of edit_text_t0 as a double
handles.parameters.t0= str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_t0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_nr_per_spatiu_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_nr_per_spatiu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_nr_per_spatiu as text
%        str2double(get(hObject,'String')) returns contents of edit_text_nr_per_spatiu as a double
handles.parameters.nr_per_spatiu = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_nr_per_spatiu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_nr_per_spatiu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_nr_per_timp_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_nr_per_timp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.parameters.nr_per_timp = str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% Hints: get(hObject,'String') returns contents of edit_text_nr_per_timp as text
%        str2double(get(hObject,'String')) returns contents of edit_text_nr_per_timp as a double


% --- Executes during object creation, after setting all properties.
function edit_text_nr_per_timp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_nr_per_timp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_text_nr_pct_Callback(hObject, eventdata, handles)
% hObject    handle to edit_text_nr_pct (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_text_nr_pct as text
%        str2double(get(hObject,'String')) returns contents of edit_text_nr_pct as a double
handles.parameters.nr_pct =  str2double(get(hObject,'String'));
handles = TEM_1_2(handles);
guidata(hObject,handles); 

% --- Executes during object creation, after setting all properties.
function edit_text_nr_pct_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_text_nr_pct (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function [val_E] = camp_E_dir(Ex_0,alpha,omega,t,beta,z,psi0)
val_E = Ex_0*exp(-alpha*z).*sin(omega*t-beta*z+psi0);

function [val_E] = camp_E_inv(Ex_0,alpha,omega,t,beta,z,psi0)
val_E = Ex_0*exp(alpha*z).*sin(omega*t+beta*z+psi0);

function zeta = impedanta_complexa(omega,mu,sigma,epsilon)
j = sqrt(-1);
zeta = sqrt(j*omega*mu/(sigma + j*omega*epsilon));

function [alpha,beta,lambda] = constanta_propagare(omega,mu,sigma,epsilon)
sigma_pe_omegaepsilon = sigma/(omega*epsilon);
muepsilon_pe_doi = mu*epsilon/2;
alpha = omega*...
    sqrt(muepsilon_pe_doi*(sqrt(sigma_pe_omegaepsilon^2+1)-1)); %[Np/m]
beta = omega*...
    sqrt(muepsilon_pe_doi*(sqrt(sigma_pe_omegaepsilon^2+1)+1)); %[rad/m]
lambda = 2*pi/beta;

function handles = TEM_1_2(handles)
f = handles.parameters.f;
eps1 = handles.parameters.eps_r_1;
mu1 = handles.parameters.mu_r_1;
sig1 = handles.parameters.sigma_1;
eps2 = handles.parameters.eps_r_2;
mu2 = handles.parameters.mu_r_2;
sig2 = handles.parameters.sigma_2;

Ed1_0 = handles.parameters.Ed1_0;
Psid1_0 = handles.parameters.psi_d1_0;
t0 = handles.parameters.t0;
nr_per_timp = handles.parameters.nr_per_timp;
nr_per_sp = handles.parameters.nr_per_spatiu;
nr_pct = handles.parameters.nr_pct;

eps0 = 1/(36*pi)*1e-9;
mu0 = 4*pi*1e-7;
omega = 2*pi*f;

zeta1 = impedanta_complexa(omega,mu1*mu0,sig1,eps1*eps0);
zeta2 = impedanta_complexa(omega,mu2*mu0,sig2,eps2*eps0);
Gamma = (zeta2 - zeta1)/(zeta2 + zeta1);
tau = 2*zeta2/(zeta2 + zeta1);

set(handles.listbox_Gamma,'String',num2str(Gamma));
set(handles.listbox_tau,'String',num2str(tau));

[alpha1,beta1,lambda1] = constanta_propagare(omega,mu1*mu0,sig1,eps1*eps0);
[alpha2,beta2,lambda2] = constanta_propagare(omega,mu2*mu0,sig2,eps2*eps0);


coeficient_reflexie = (zeta2 - zeta1)/(zeta2 + zeta1);
coeficient_transmisie = 2*zeta2/(zeta2 + zeta1);

zmin = -nr_per_sp*lambda1;
zmax = nr_per_sp*lambda2;
vector_z_mediul1 = linspace(zmin,0,nr_pct);
vector_z_mediul2 = linspace(0,zmax,nr_pct);

val_max_E = 2*Ed1_0*exp(-alpha1*zmin);

j = sqrt(-1);
Ed1_0_complex = Ed1_0*exp(j*Psid1_0);
Ei1_0_complex = coeficient_reflexie*Ed1_0_complex;
Ed2_0_complex = coeficient_transmisie*Ed1_0_complex;
abs_Ed2_0_complex = abs(Ed2_0_complex);
phase_Ed2_0_complex = phase(Ed2_0_complex);
abs_Ei1_0_complex = abs(Ei1_0_complex);
phase_Ei1_0_complex = phase(Ei1_0_complex);

%T = 1/f;
%tmin = t0;
%tmax = tmin + nr_per_timp*T;

[val_E_mediul2] = ...
    camp_E_dir(abs_Ed2_0_complex,alpha2,omega,t0,beta2,...
    vector_z_mediul2,phase_Ed2_0_complex);
[val_E_mediul1_dir] = ...
    camp_E_dir(Ed1_0,alpha1,omega,t0,beta1,...
    vector_z_mediul1,Psid1_0);
[val_E_mediul1_inv] = camp_E_inv(abs_Ei1_0_complex,alpha1,omega,t0,beta1,...
    vector_z_mediul1,phase_Ei1_0_complex);
val_E_mediul1 = val_E_mediul1_dir + val_E_mediul1_inv;

axes(handles.axes_E);
cla;
plot(vector_z_mediul2,val_E_mediul2,'r:','Linewidth',2);
hold on;
plot(vector_z_mediul1,val_E_mediul1,'r-','Linewidth',2);
axis([zmin zmax,-val_max_E ,val_max_E ]);
grid on;
xlabel('z [m]');
ylabel(strcat('Ex(z,',num2str(t0),')'));


% --- Executes on button press in pushb_animatie_E.
function pushb_animatie_E_Callback(hObject, eventdata, handles)
% hObject    handle to pushb_animatie_E (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
f = handles.parameters.f;
eps1 = handles.parameters.eps_r_1;
mu1 = handles.parameters.mu_r_1;
sig1 = handles.parameters.sigma_1;
eps2 = handles.parameters.eps_r_2;
mu2 = handles.parameters.mu_r_2;
sig2 = handles.parameters.sigma_2;

Ed1_0 = handles.parameters.Ed1_0;
Psid1_0 = handles.parameters.psi_d1_0;
t0 = handles.parameters.t0;
nr_per_timp = handles.parameters.nr_per_timp;
nr_per_sp = handles.parameters.nr_per_spatiu;
nr_pct = handles.parameters.nr_pct;

eps0 = 1/(36*pi)*1e-9;
mu0 = 4*pi*1e-7;
omega = 2*pi*f;

zeta1 = impedanta_complexa(omega,mu1*mu0,sig1,eps1*eps0);
zeta2 = impedanta_complexa(omega,mu2*mu0,sig2,eps2*eps0);
[alpha1,beta1,lambda1] = constanta_propagare(omega,mu1*mu0,sig1,eps1*eps0);
[alpha2,beta2,lambda2] = constanta_propagare(omega,mu2*mu0,sig2,eps2*eps0);


coeficient_reflexie = (zeta2 - zeta1)/(zeta2 + zeta1);
coeficient_transmisie = 2*zeta2/(zeta2 + zeta1);

zmin = -nr_per_sp*lambda1;
zmax = nr_per_sp*lambda2;
vector_z_mediul1 = linspace(zmin,0,nr_pct);
vector_z_mediul2 = linspace(0,zmax,nr_pct);

val_max_E = 2*Ed1_0*exp(-alpha1*zmin);

j = sqrt(-1);
Ed1_0_complex = Ed1_0*exp(j*Psid1_0);
Ei1_0_complex = coeficient_reflexie*Ed1_0_complex;
Ed2_0_complex = coeficient_transmisie*Ed1_0_complex;
abs_Ed2_0_complex = abs(Ed2_0_complex);
phase_Ed2_0_complex = phase(Ed2_0_complex);
abs_Ei1_0_complex = abs(Ei1_0_complex);
phase_Ei1_0_complex = phase(Ei1_0_complex);

T = 1/f;
tmin = t0;
tmax = tmin + nr_per_timp*T;
vector_t = linspace(tmin,tmax,nr_pct);
axes(handles.axes_E);
%cla;
for k = 1:length(vector_t)
    [val_E_mediul2] = ...
        camp_E_dir(abs_Ed2_0_complex,alpha2,omega,vector_t(k),beta2,...
        vector_z_mediul2,phase_Ed2_0_complex);
    [val_E_mediul1_dir] = ...
        camp_E_dir(Ed1_0, alpha1,omega,vector_t(k),beta1,...
        vector_z_mediul1,Psid1_0);
    [val_E_mediul1_inv] = camp_E_inv(abs_Ei1_0_complex, alpha1,omega,vector_t(k),beta1,...
        vector_z_mediul1,phase_Ei1_0_complex);
    val_E_mediul1 = val_E_mediul1_dir + val_E_mediul1_inv;
    hold off;
    plot(vector_z_mediul2,val_E_mediul2,'r:','Linewidth',2);
    hold on;
    plot(vector_z_mediul1,val_E_mediul1,'r-','Linewidth',2);
    axis([zmin zmax,-val_max_E ,val_max_E ]);
    grid on;
    xlabel('z [m]');
    ylabel(strcat('Ex(z,',num2str(t0),')'));
    drawnow;
end



% --- Executes on selection change in listbox_Gamma.
function listbox_Gamma_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_Gamma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_Gamma contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_Gamma


% --- Executes during object creation, after setting all properties.
function listbox_Gamma_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_Gamma (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_tau.
function listbox_tau_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_tau (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_tau contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_tau


% --- Executes during object creation, after setting all properties.
function listbox_tau_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_tau (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


