function varargout = demo7(varargin)
% DEMO7 M-file for demo7.fig
%      DEMO7 - ilustrates propagation modes TM and TE in a 
%              lossless rectangular waveguide

% Code by Gabriela Ciuprina 
% gabriela@lmn.pub.ro
% www.lmn.pub.ro/~gabriela
% Last update by GC - 12 May 2008

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @demo7_OpeningFcn, ...
    'gui_OutputFcn',  @demo7_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo7 is made visible.
function demo7_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo7 (see VARARGIN)

% Choose default command line output for demo7
handles.parameters.a = 2.5e-2;
handles.parameters.b = 1e-2;
handles.parameters.eps_r = 4;
handles.parameters.mu_r = 1;
handles.parameters.f = 20e9;
handles.parameters.mode = 'TM';
handles.parameters.m = 2;
handles.parameters.n = 1;
handles.parameters.x0 = 1.25e-2;
handles.parameters.y0 = 0.5e-2;
handles.parameters.z0 = 1.2e-3;
handles.parameters.t0 = 0;
handles.parameters.nr_pct_x = 10;
handles.parameters.nr_pct_y = 10;
handles.parameters.nr_pct_z = 20;
handles.parameters.nr_pct_t = 100;
handles.parameters.nr_per_spatiu = 1;
handles.parameters.nr_per_timp = 1;
handles = update_guide_info(handles);
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes demo7 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo7_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit_a_Callback(hObject, eventdata, handles)
% hObject    handle to edit_a (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_a as text
%        str2double(get(hObject,'String')) returns contents of edit_a as a double
handles.parameters.a = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_a_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_a (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_b_Callback(hObject, eventdata, handles)
% hObject    handle to edit_b (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_b as text
%        str2double(get(hObject,'String')) returns contents of edit_b as a double
handles.parameters.b = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit_b_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_b (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_eps_r_Callback(hObject, eventdata, handles)
% hObject    handle to edit_eps_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_eps_r as text
%        str2double(get(hObject,'String')) returns contents of edit_eps_r as a double
handles.parameters.eps_r = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_eps_r_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_eps_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_mu_r_Callback(hObject, eventdata, handles)
% hObject    handle to edit_mu_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_mu_r as text
%        str2double(get(hObject,'String')) returns contents of edit_mu_r as a double
handles.parameters.mu_r = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit_mu_r_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_mu_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_f_Callback(hObject, eventdata, handles)
% hObject    handle to edit_f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_f as text
%        str2double(get(hObject,'String')) returns contents of edit_f as a double
handles.parameters.f = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_f_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_mod.
function popupmenu_mod_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_mod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu_mod contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_mod
modes = get(hObject,'String');
handles.parameters.mode = modes{get(hObject,'Value')};
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function popupmenu_mod_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_mod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_m_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m as text
%        str2double(get(hObject,'String')) returns contents of edit_m as a double
handles.parameters.m = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_m_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_n_Callback(hObject, eventdata, handles)
% hObject    handle to edit_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_n as text
%        str2double(get(hObject,'String')) returns contents of edit_n as a double
handles.parameters.n = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_n_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_x0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_x0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_x0 as text
%        str2double(get(hObject,'String')) returns contents of edit_x0 as a double
handles.parameters.x0 = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_x0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_x0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_y0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_y0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_y0 as text
%        str2double(get(hObject,'String')) returns contents of edit_y0 as a double
handles.parameters.y0 = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_y0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_y0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_z0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_z0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_z0 as text
%        str2double(get(hObject,'String')) returns contents of edit_z0 as a double
handles.parameters.z0 = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_z0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_z0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_per_spatiu_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_per_spatiu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_per_spatiu as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_per_spatiu as a double
handles.parameters.nr_per_spatiu = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_per_spatiu_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_per_spatiu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_per_timp_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_per_timp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_per_timp as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_per_timp as a double
handles.parameters.nr_per_timp = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_per_timp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_per_timp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_x_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_x as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_x as a double
handles.parameters.nr_pct_x = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_y_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_y as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_y as a double
handles.parameters.nr_pct_y = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_z_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_z as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_z as a double
handles.parameters.nr_pct_z = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_z_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_t_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_t as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_t as a double
handles.parameters.nr_pct_t = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_t_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_f_c.
function listbox_f_c_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_f_c (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_f_c contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_f_c


% --- Executes during object creation, after setting all properties.
function listbox_f_c_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_f_c (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% --- Executes on selection change in listbox_lambda_c.
function listbox_lambda_c_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_lambda_c (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_lambda_c contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_lambda_c


% --- Executes during object creation, after setting all properties.
function listbox_lambda_c_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_lambda_c (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_beta.
function listbox_beta_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_beta contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_beta


% --- Executes during object creation, after setting all properties.
function listbox_beta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_beta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_v.
function listbox_v_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_v (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_v contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_v


% --- Executes during object creation, after setting all properties.
function listbox_v_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_v (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_zeta.
function listbox_zeta_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_zeta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_zeta contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_zeta


% --- Executes during object creation, after setting all properties.
function listbox_zeta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_zeta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_animatie_x0y.
function pushbutton_animatie_xoy_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_animatie_x0y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
a = handles.parameters.a;
b = handles.parameters.b;
f = handles.parameters.f;
omega = 2*pi*f;
kx = m*pi/a;
ky = n*pi/b;

beta = handles.parameters.beta; %omega*sqrt(miu*epsilon)*sqrt(1-(f_c/f)^2);
lambda = 2*pi/beta;
T = 1/f;
kt_patrat = kx^2 + ky^2;

z_max = handles.parameters.nr_per_spatiu*lambda;
T_max = handles.parameters.nr_per_timp*T;
vector_z = linspace(0,z_max,handles.parameters.nr_pct_z);
vector_y = linspace(0,b,handles.parameters.nr_pct_y);
vector_x = linspace(0,a,handles.parameters.nr_pct_x);
vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
figure(1);
for k = 1:length(vector_t)
    t_crt = vector_t(k);
    draw_at_one_time_xoy(handles,t_crt,vector_x,vector_y,vector_z,...
        z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta);
end


function handles = update_guide_info(handles)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
a = handles.parameters.a;
b = handles.parameters.b;
f = handles.parameters.f;
v_prim = 1/sqrt(miu*epsilon);
omega = 2*pi*f;
kx = m*pi/a;
ky = n*pi/b;
f_c = v_prim/(2*pi)*sqrt(kx^2+ky^2);
set(handles.listbox_f_c,'String',num2str(f_c));
handles.parameters.f_c = f_c;
lambda_c = v_prim/f_c;
set(handles.listbox_lambda_c,'String',num2str(lambda_c));
handles.parameters.lambda_c = lambda_c;
beta = omega*sqrt(miu*epsilon)*sqrt(1-(f_c/f)^2);
set(handles.listbox_beta,'String',num2str(beta));
handles.parameters.beta = beta;
v = omega/beta;
lambda = 2*pi/beta;
set(handles.listbox_v,'String',num2str(v));
handles.parameters.v = v;
if strcmp(handles.parameters.mode,'TM')
    zeta = sqrt(miu/epsilon)*sqrt(1-(f_c/f)^2);
else %TE
    zeta = sqrt(miu/epsilon)/sqrt(1-(f_c/f)^2);
end
set(handles.listbox_zeta,'String',num2str(zeta));
handles.parameters.zeta = zeta;
T = 1/f;

kt_patrat = kx^2 + ky^2;
kz_patrat =  kt_patrat - omega^2*miu*epsilon;
if kz_patrat >= 0
    errordlg('Nu exista propagare');
else
    axes(handles.axes_yoz);
    cla;
    axes(handles.axes_xoz);
    cla;
    axes(handles.axes_xoy);
    cla;
end

function ez = TM_Ez(x,y,z,t,kx,ky,omega,beta)
ez = sin(kx.*x).*sin(ky.*y).*sin(omega.*t-beta.*z);

function ey = TM_Ey(x,y,z,t,kx,ky,kt_patrat,omega,beta)
ey = beta/kt_patrat*...
    ky*sin(kx.*x).*cos(ky.*y).*sin(omega.*t-beta.*z-pi/2);

function ex = TM_Ex(x,y,z,t,kx,ky,kt_patrat,omega,beta)
ex = beta/kt_patrat*...
    kx*cos(kx.*x).*sin(ky.*y).*sin(omega.*t-beta.*z-pi/2);

function hx = TM_Hx(x,y,z,t,kx,ky,kt_patrat,omega,beta,epsilon)
hx = omega*epsilon/kt_patrat*...
    ky*sin(kx.*x).*cos(ky.*y).*sin(omega.*t-beta.*z+pi/2);

function hy = TM_Hy(x,y,z,t,kx,ky,kt_patrat,omega,beta,epsilon)
hy = omega*epsilon/kt_patrat*...
    kx*cos(kx.*x).*sin(ky.*y).*sin(omega.*t-beta.*z-pi/2);

function val = TM_max_ExEy(x,y,kx,ky,kt_patrat,beta)
ex = -1/kt_patrat*...
    beta*kx*cos(kx.*x).*sin(ky.*y);
ey = -1/kt_patrat*...
    beta*ky*sin(kx.*x).*cos(ky.*y);
val = sqrt(max(max(ex.^2.+ey.^2)));

function val = TM_max_HxHy(x,y,kx,ky,kt_patrat,omega,epsilon)
hx = 1/kt_patrat*...
    omega*epsilon*ky*sin(kx.*x).*cos(ky.*y);
hy = 1/kt_patrat*...
    omega*epsilon*kx*cos(kx.*x).*sin(ky.*y);
val = sqrt(max(max(hx.^2.+hy.^2)));

function hz = TE_Hz(x,y,z,t,kx,ky,omega,beta)
hz = cos(kx.*x).*cos(ky.*y).*sin(omega.*t-beta.*z);

function hy = TE_Hy(x,y,z,t,kx,ky,kt_patrat,omega,beta)
hy = beta/kt_patrat*...
    ky*cos(kx.*x).*sin(ky.*y).*sin(omega.*t-beta.*z+pi/2);

function hx = TE_Hx(x,y,z,t,kx,ky,kt_patrat,omega,beta)
hx = beta/kt_patrat*...
    kx*sin(kx.*x).*cos(ky.*y).*sin(omega.*t-beta.*z+pi/2);

function ex = TE_Ex(x,y,z,t,kx,ky,kt_patrat,omega,beta,miu)
ex = omega*miu/kt_patrat*...
    ky*cos(kx.*x).*sin(ky.*y).*sin(omega.*t-beta.*z+pi/2);

function ey = TE_Ey(x,y,z,t,kx,ky,kt_patrat,omega,beta,miu)
ey = omega*miu/kt_patrat*...
    kx*sin(kx.*x).*cos(ky.*y).*sin(omega.*t-beta.*z-pi/2);


function val = TE_max_ExEy(x,y,kx,ky,kt_patrat,omega,miu)
ex = 1/kt_patrat*...
    omega*miu*ky*cos(kx.*x).*sin(ky.*y);
ey = -1/kt_patrat*...
    omega*miu*kx*sin(kx.*x).*cos(ky.*y);
val = sqrt(max(max(ex.^2.+ey.^2)));

function val = TE_max_HxHy(x,y,kx,ky,kt_patrat,beta)
hx = 1/kt_patrat*...
    beta*kx*sin(kx.*x).*cos(ky.*y);
hy = 1/kt_patrat*...
    beta*ky*cos(kx.*x).*sin(ky.*y);
val = sqrt(max(max(hx.^2.+hy.^2)));

function draw_at_one_time(handles,t_crt,vector_x,vector_y,vector_z,...
    z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta)

axes(handles.axes_xoy);
draw_at_one_time_xoy(handles,t_crt,vector_x,vector_y,vector_z,...
    z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta);
axes(handles.axes_xoz);
draw_at_one_time_xoz(handles,t_crt,vector_x,vector_y,vector_z,...
    z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta);
axes(handles.axes_yoz);
draw_at_one_time_yoz(handles,t_crt,vector_x,vector_y,vector_z,...
    z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta);


function edit_t0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_t0 as text
%        str2double(get(hObject,'String')) returns contents of edit_t0 as a double
handles.parameters.t0 = str2double(get(hObject,'String'));
handles = update_guide_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_t0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_camp_t0.
function push_camp_t0_Callback(hObject, eventdata, handles)
% hObject    handle to push_camp_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
a = handles.parameters.a;
b = handles.parameters.b;
f = handles.parameters.f;
v_prim = 1/sqrt(miu*epsilon);
omega = 2*pi*f;
kx = m*pi/a;
ky = n*pi/b;
f_c = v_prim/(2*pi)*sqrt(kx^2+ky^2);
handles.parameters.f_c = f_c;
lambda_c = v_prim/f_c;
handles.parameters.lambda_c = lambda_c;
beta = omega*sqrt(miu*epsilon)*sqrt(1-(f_c/f)^2);
handles.parameters.beta = beta;
v = omega/beta;
lambda = 2*pi/beta;
handles.parameters.v = v;
if strcmp(handles.parameters.mode,'TM')
    zeta = sqrt(miu/epsilon)*sqrt(1-(f_c/f)^2);
else %TE
    zeta = sqrt(miu/epsilon)/sqrt(1-(f_c/f)^2);
end
handles.parameters.zeta = zeta;
T = 1/f;

kt_patrat = kx^2 + ky^2;
kz_patrat =  kt_patrat - omega^2*miu*epsilon;
if kz_patrat >= 0
    errordlg('Nu exista propagare');
else
    z_max = handles.parameters.nr_per_spatiu*lambda;
    T_max = handles.parameters.nr_per_timp*T;
    vector_z = linspace(0,z_max,handles.parameters.nr_pct_z);
    vector_y = linspace(0,b,handles.parameters.nr_pct_y);
    vector_x = linspace(0,a,handles.parameters.nr_pct_x);
    vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
    t_crt = handles.parameters.t0;
    draw_at_one_time(handles,t_crt,vector_x,vector_y,vector_z,...
        z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta);
end

function draw_at_one_time_xoy(handles,t_crt,vector_x,vector_y,vector_z,...
    z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta)
x0 = handles.parameters.x0;
y0 = handles.parameters.y0;
z0 = handles.parameters.z0;
b = handles.parameters.b;
a = handles.parameters.a;

%figure(1);
plot([0 a a 0 0],[0 0 b b 0],'b','Linewidth',2);
hold on;
axis([0 1.1*a 0 1.1*b]);
xlabel('x');
ylabel('y');
[X,Y] = meshgrid(vector_x,vector_y);
if strcmp(handles.parameters.mode,'TM')
    val_max_Exy = TM_max_ExEy(X,Y,kx,ky,kt_patrat,beta);
    val_max_Hxy = TM_max_HxHy(X,Y,kx,ky,kt_patrat,omega,epsilon);
    ey = TM_Ey(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    ex = TM_Ex(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    M_E = sqrt(max(max(ex.^2+ey.^2)));
    scale_E = M_E/val_max_Exy;
    quiver(X,Y,ex,ey,scale_E,'r');
    hx = TM_Hx(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    hy = TM_Hy(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    M_H = sqrt(max(max(hx.^2+hy.^2)));
    scale_H = M_H/val_max_Hxy;
    quiver(X,Y,hx,hy,scale_H,'g');
    drawnow;
    hold off;
else
    val_max_Exy = TE_max_ExEy(X,Y,kx,ky,kt_patrat,omega,miu);
    val_max_Hxy = TE_max_HxHy(X,Y,kx,ky,kt_patrat,beta);
    ey = TE_Ey(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    ex = TE_Ex(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    M_E = sqrt(max(max(ex.^2+ey.^2)));
    scale_E = M_E/val_max_Exy;
    quiver(X,Y,ex,ey,scale_E,'r');
    hx = TE_Hx(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    hy = TE_Hy(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    M_H = sqrt(max(max(hx.^2+hy.^2)));
    scale_H = M_H/val_max_Hxy;
    quiver(X,Y,hx,hy,scale_H,'g');
    drawnow;
    hold off;
end


% --- Executes on button press in pushbutton_animatie_xoz.
function pushbutton_animatie_xoz_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_animatie_xoz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
a = handles.parameters.a;
b = handles.parameters.b;
f = handles.parameters.f;
omega = 2*pi*f;
kx = m*pi/a;
ky = n*pi/b;

beta = handles.parameters.beta; %omega*sqrt(miu*epsilon)*sqrt(1-(f_c/f)^2);
lambda = 2*pi/beta;
T = 1/f;
kt_patrat = kx^2 + ky^2;

z_max = handles.parameters.nr_per_spatiu*lambda;
T_max = handles.parameters.nr_per_timp*T;
vector_z = linspace(0,z_max,handles.parameters.nr_pct_z);
vector_y = linspace(0,b,handles.parameters.nr_pct_y);
vector_x = linspace(0,a,handles.parameters.nr_pct_x);
vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
figure(2);
for k = 1:length(vector_t)
    t_crt = vector_t(k);
    draw_at_one_time_xoz(handles,t_crt,vector_x,vector_y,vector_z,...
        z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta);
end

function draw_at_one_time_xoz(handles,t_crt,vector_x,vector_y,vector_z,...
    z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta)
x0 = handles.parameters.x0;
y0 = handles.parameters.y0;
z0 = handles.parameters.z0;
b = handles.parameters.b;
a = handles.parameters.a;

%figure(2);
plot([0 0],[0 z_max],'b','Linewidth',2);
hold on;
plot([a a],[0 z_max],'b','Linewidth',2);
axis([0 1.1*a 0 1.1*z_max]);
xlabel('x');
ylabel('z');
[X,Z] = meshgrid(vector_x,vector_z);
if strcmp(handles.parameters.mode,'TM')
    ez = TM_Ez(X,y0,Z,t_crt,kx,ky,omega,beta);
    ex = TM_Ex(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    quiver(X,Z,ex,ez,'r');
    hx = TM_Hx(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    hz = zeros(size(hx));
    quiver(X,Z,hx,hz,'g');
    drawnow;
    hold off;
else
    ex = TE_Ex(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    ez = zeros(size(ex));
    quiver(X,Z,ex,ez,'r');
    hx = TE_Hx(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    hz = TE_Hz(X,y0,Z,t_crt,kx,ky,omega,beta);
    quiver(X,Z,hx,hz,'g');
    drawnow;
    hold off;
end



% --- Executes on button press in pushbutton_animatie_yoz.
function pushbutton_animatie_yoz_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_animatie_yoz (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
a = handles.parameters.a;
b = handles.parameters.b;
f = handles.parameters.f;
omega = 2*pi*f;
kx = m*pi/a;
ky = n*pi/b;

beta = handles.parameters.beta; %omega*sqrt(miu*epsilon)*sqrt(1-(f_c/f)^2);
lambda = 2*pi/beta;
T = 1/f;
kt_patrat = kx^2 + ky^2;

z_max = handles.parameters.nr_per_spatiu*lambda;
T_max = handles.parameters.nr_per_timp*T;
vector_z = linspace(0,z_max,handles.parameters.nr_pct_z);
vector_y = linspace(0,b,handles.parameters.nr_pct_y);
vector_x = linspace(0,a,handles.parameters.nr_pct_x);
vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
figure(3);
for k = 1:length(vector_t)
    t_crt = vector_t(k);
    draw_at_one_time_yoz(handles,t_crt,vector_x,vector_y,vector_z,...
        z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta);
end

function draw_at_one_time_yoz(handles,t_crt,vector_x,vector_y,vector_z,...
    z_max,kx,ky,kt_patrat,omega,epsilon,miu,beta)
x0 = handles.parameters.x0;
y0 = handles.parameters.y0;
z0 = handles.parameters.z0;
b = handles.parameters.b;
a = handles.parameters.a;
%figure(3);
plot([0 0],[0 z_max],'b','Linewidth',2);
hold on;
plot([b b],[0 z_max],'b','Linewidth',2);
axis([0 1.1*b 0 1.1*z_max]);
xlabel('y');
ylabel('z');
[Y,Z] = meshgrid(vector_y,vector_z);
if strcmp(handles.parameters.mode,'TM')
    ez = TM_Ez(x0,Y,Z,t_crt,kx,ky,omega,beta);
    ey = TM_Ey(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    quiver(Y,Z,ey,ez,'r');
    hy = TM_Hy(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    hz = zeros(size(hy));
    quiver(Y,Z,hy,hz,'g');
    drawnow;
    hold off;
else %TE
    ey = TE_Ey(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    ez = zeros(size(ey));
    quiver(Y,Z,ey,ez,'r');
    hy = TE_Hy(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    hz = TE_Hz(x0,Y,Z,t_crt,kx,ky,omega,beta);
    quiver(Y,Z,hy,hz,'g');
    drawnow;
    hold off;
end
