function varargout = demo8(varargin)
% DEMO8 M-file for demo8.fig
%      DEMO8 - ilustrates propagation modes TM and TE in a
%              lossless rectangular waveguide resonator

% Code by Gabriela Ciuprina
% gabriela@lmn.pub.ro
% www.lmn.pub.ro/~gabriela
% Last update by GC - 15 May 2008

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @demo8_OpeningFcn, ...
    'gui_OutputFcn',  @demo8_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before demo8 is made visible.
function demo8_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to demo8 (see VARARGIN)
handles.parameters.a = 2.5e-2;
handles.parameters.b = 1e-2;
handles.parameters.c = 5e-2;
handles.parameters.eps_r = 4;
handles.parameters.mu_r = 1;
handles.parameters.mode = 'TM';
handles.parameters.m = 2;
handles.parameters.n = 1;
handles.parameters.p = 1;
handles.parameters.x0 = 1.25e-2;
handles.parameters.y0 = 0.5e-2;
handles.parameters.z0 = 2.5e-2;
handles.parameters.t0 = 0;
handles.parameters.nr_pct_x = 10;
handles.parameters.nr_pct_y = 10;
handles.parameters.nr_pct_z = 20;
handles.parameters.nr_pct_t = 100;
handles.parameters.nr_per_timp = 1;
handles = update_cavity_info(handles);
handles.output = hObject;
guidata(hObject, handles);

% UIWAIT makes demo8 wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = demo8_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function edit_a_Callback(hObject, eventdata, handles)
% hObject    handle to edit_a (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_a as text
%        str2double(get(hObject,'String')) returns contents of edit_a as a double
handles.parameters.a = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit_a_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_a (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_b_Callback(hObject, eventdata, handles)
% hObject    handle to edit_b (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_b as text
%        str2double(get(hObject,'String')) returns contents of edit_b as a double
handles.parameters.b = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit_b_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_b (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_c_Callback(hObject, eventdata, handles)
% hObject    handle to edit_c (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_c as text
%        str2double(get(hObject,'String')) returns contents of edit_c as a double
handles.parameters.c = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit_c_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_c (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





function edit_eps_r_Callback(hObject, eventdata, handles)
% hObject    handle to edit_eps_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_eps_r as text
%        str2double(get(hObject,'String')) returns contents of edit_eps_r as a double
handles.parameters.eps_r = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit_eps_r_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_eps_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_mu_r_Callback(hObject, eventdata, handles)
% hObject    handle to edit_mu_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_mu_r as text
%        str2double(get(hObject,'String')) returns contents of edit_mu_r as a double
handles.parameters.mu_r = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);


% --- Executes during object creation, after setting all properties.
function edit_mu_r_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_mu_r (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_mod.
function popupmenu_mod_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_mod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu_mod contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_mod
modes = get(hObject,'String');
handles.parameters.mode = modes{get(hObject,'Value')};
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function popupmenu_mod_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_mod (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_m_Callback(hObject, eventdata, handles)
% hObject    handle to edit_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_m as text
%        str2double(get(hObject,'String')) returns contents of edit_m as a double
handles.parameters.m = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_m_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_n_Callback(hObject, eventdata, handles)
% hObject    handle to edit_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_n as text
%        str2double(get(hObject,'String')) returns contents of edit_n as a double
handles.parameters.n = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_n_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_p_Callback(hObject, eventdata, handles)
% hObject    handle to edit_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_p as text
%        str2double(get(hObject,'String')) returns contents of edit_p as a double
handles.parameters.p = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_p_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_x0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_x0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_x0 as text
%        str2double(get(hObject,'String')) returns contents of edit_x0 as a double
handles.parameters.x0 = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_x0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_x0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_y0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_y0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_y0 as text
%        str2double(get(hObject,'String')) returns contents of edit_y0 as a double
handles.parameters.y0 = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_y0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_y0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_z0_Callback(hObject, eventdata, handles)
% hObject    handle to edit_z0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_z0 as text
%        str2double(get(hObject,'String')) returns contents of edit_z0 as a double
handles.parameters.z0 = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_z0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_z0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_x_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_x as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_x as a double
handles.parameters.nr_pct_x = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_y_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_y as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_y as a double
handles.parameters.nr_pct_y = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_y_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_y (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_z_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_z as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_z as a double
handles.parameters.nr_pct_z = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_z_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_z (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_per_timp_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_per_timp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_per_timp as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_per_timp as a double
handles.parameters.nr_per_timp = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_per_timp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_per_timp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_nr_pct_t_Callback(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_nr_pct_t as text
%        str2double(get(hObject,'String')) returns contents of edit_nr_pct_t as a double
handles.parameters.nr_pct_t = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_nr_pct_t_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_nr_pct_t (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_t0_Callback(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit17 as text
%        str2double(get(hObject,'String')) returns contents of edit17 as a double
handles.parameters.t0 = str2double(get(hObject,'String'));
handles = update_cavity_info(handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit_t0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_f_0.
function listbox_f_0_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_f_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_f_0 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_f_0


% --- Executes during object creation, after setting all properties.
function listbox_f_0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_f_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in listbox_lambda_0.
function listbox_lambda_0_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_lambda_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_lambda_0 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_lambda_0


% --- Executes during object creation, after setting all properties.
function listbox_lambda_0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_lambda_0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_camp_t0.
function pushbutton_camp_t0_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_camp_t0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;
a = handles.parameters.a;
b = handles.parameters.b;
c = handles.parameters.c;
v_prim = 1/sqrt(miu*epsilon);
f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
omega = 2*pi*f_0;
kx = m*pi/a;
ky = n*pi/b;
beta = p*pi/c;
T = 1/f_0;

kt_patrat = kx^2 + ky^2;

T_max = handles.parameters.nr_per_timp*T;
vector_z = linspace(0,c,handles.parameters.nr_pct_z);
vector_y = linspace(0,b,handles.parameters.nr_pct_y);
vector_x = linspace(0,a,handles.parameters.nr_pct_x);
vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
t_crt = handles.parameters.t0;
draw_at_one_time(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta);

% --- Executes on button press in pushbutton_animatie_xoy.
function pushbutton_animatie_xoy_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_animatie_xoy (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;
a = handles.parameters.a;
b = handles.parameters.b;
c = handles.parameters.c;
v_prim = 1/sqrt(miu*epsilon);
f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
omega = 2*pi*f_0;
kx = m*pi/a;
ky = n*pi/b;
beta = p*pi/c;
T = 1/f_0;

kt_patrat = kx^2 + ky^2;

T_max = handles.parameters.nr_per_timp*T;
vector_z = linspace(0,c,handles.parameters.nr_pct_z);
vector_y = linspace(0,b,handles.parameters.nr_pct_y);
vector_x = linspace(0,a,handles.parameters.nr_pct_x);
vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
figure(1);
for k = 1:length(vector_t)
    t_crt = vector_t(k);
    draw_at_one_time_xoy(handles,t_crt,vector_x,vector_y,vector_z,...
        kx,ky,kt_patrat,omega,epsilon,miu,beta);
end

% --- Executes on button press in pushbutton3.
function pushbutton_animatie_xoz_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;
a = handles.parameters.a;
b = handles.parameters.b;
c = handles.parameters.c;
v_prim = 1/sqrt(miu*epsilon);
f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
omega = 2*pi*f_0;
kx = m*pi/a;
ky = n*pi/b;
beta = p*pi/c;
T = 1/f_0;

kt_patrat = kx^2 + ky^2;

T_max = handles.parameters.nr_per_timp*T;
vector_z = linspace(0,c,handles.parameters.nr_pct_z);
vector_y = linspace(0,b,handles.parameters.nr_pct_y);
vector_x = linspace(0,a,handles.parameters.nr_pct_x);
vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
figure(2);
for k = 1:length(vector_t)
    t_crt = vector_t(k);
    draw_at_one_time_xoz(handles,t_crt,vector_x,vector_y,vector_z,...
        kx,ky,kt_patrat,omega,epsilon,miu,beta);
end

% --- Executes on button press in pushbutton4.
function pushbutton_animatie_yoz_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;
a = handles.parameters.a;
b = handles.parameters.b;
c = handles.parameters.c;
v_prim = 1/sqrt(miu*epsilon);
f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
omega = 2*pi*f_0;
kx = m*pi/a;
ky = n*pi/b;
beta = p*pi/c;
T = 1/f_0;

kt_patrat = kx^2 + ky^2;

T_max = handles.parameters.nr_per_timp*T;
vector_z = linspace(0,c,handles.parameters.nr_pct_z);
vector_y = linspace(0,b,handles.parameters.nr_pct_y);
vector_x = linspace(0,a,handles.parameters.nr_pct_x);
vector_t = linspace(0,T_max,handles.parameters.nr_pct_t);
figure(3);
for k = 1:length(vector_t)
    t_crt = vector_t(k);
    draw_at_one_time_yoz(handles,t_crt,vector_x,vector_y,vector_z,...
        kx,ky,kt_patrat,omega,epsilon,miu,beta);
end

function handles = update_cavity_info(handles)
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;

a = handles.parameters.a;
b = handles.parameters.b;
c = handles.parameters.c;
v_prim = 1/sqrt(miu*epsilon);

f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
set(handles.listbox_f_0,'String',num2str(f_0*1e-9));
lambda_0 = 2/sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
set(handles.listbox_lambda_0,'String',num2str(lambda_0*1e3));
axes(handles.axes_xoy); cla;
axes(handles.axes_yoz); cla;
axes(handles.axes_xoz); cla;

function draw_at_one_time(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta)

axes(handles.axes_xoy);
draw_at_one_time_xoy(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta);
axes(handles.axes_xoz);
draw_at_one_time_xoz(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta);
axes(handles.axes_yoz);
draw_at_one_time_yoz(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta);



function draw_at_one_time_xoy(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta)
x0 = handles.parameters.x0;
y0 = handles.parameters.y0;
z0 = handles.parameters.z0;
c = handles.parameters.c;
b = handles.parameters.b;
a = handles.parameters.a;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
v_prim = 1/sqrt(miu*epsilon);
kx = m*pi/a;
ky = n*pi/b;
kt_patrat = kx^2 + ky*2;
beta = p*pi/c;
f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
omega = 2*pi*f_0;

plot([0 a a 0 0],[0 0 b b 0],'b','Linewidth',2);
hold on;
axis([0 1.1*a 0 1.1*b]);
xlabel('x');
ylabel('y');
[X,Y] = meshgrid(vector_x,vector_y);
if strcmp(handles.parameters.mode,'TM')
    val_max_Exy = TM_max_ExEy(X,Y,z0,kx,ky,kt_patrat,beta);
    val_max_Hxy = TM_max_HxHy(X,Y,z0,kx,ky,kt_patrat,omega,epsilon,beta);
    ey = TM_Ey(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    ex = TM_Ex(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    M_E = sqrt(max(max(ex.^2+ey.^2)));
    scale_E = M_E/val_max_Exy;
    quiver(X,Y,ex,ey,scale_E,'r');
    hx = TM_Hx(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    hy = TM_Hy(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    M_H = sqrt(max(max(hx.^2+hy.^2)));
    scale_H = M_H/val_max_Hxy;
    quiver(X,Y,hx,hy,scale_H,'g');
    drawnow;
    hold off;
else
    val_max_Exy = TE_max_ExEy(X,Y,z0,kx,ky,kt_patrat,omega,miu,beta);
    val_max_Hxy = TE_max_HxHy(X,Y,z0,kx,ky,kt_patrat,beta);
    ey = TE_Ey(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    ex = TE_Ex(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    M_E = sqrt(max(max(ex.^2+ey.^2)));
    scale_E = M_E/val_max_Exy;
    quiver(X,Y,ex,ey,scale_E,'r');
    hx = TE_Hx(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    hy = TE_Hy(X,Y,z0,t_crt,kx,ky,kt_patrat,omega,beta);
    M_H = sqrt(max(max(hx.^2+hy.^2)));
    scale_H = M_H/val_max_Hxy;
    quiver(X,Y,hx,hy,scale_H,'g');
    drawnow;
    hold off;
end

function draw_at_one_time_xoz(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta)
x0 = handles.parameters.x0;
y0 = handles.parameters.y0;
z0 = handles.parameters.z0;
c = handles.parameters.c;
b = handles.parameters.b;
a = handles.parameters.a;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
v_prim = 1/sqrt(miu*epsilon);
kx = m*pi/a;
ky = n*pi/b;
kt_patrat = kx^2 + ky*2;
beta = p*pi/c;
f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
omega = 2*pi*f_0;

plot([0 0],[0 c],'b','Linewidth',2);
hold on;
plot([a a],[0 c],'b','Linewidth',2);
axis([0 1.1*a 0 1.1*c]);
plot([0 a],[0 0],'b','Linewidth',2);
plot([0 a],[c c],'b','Linewidth',2);
xlabel('x');
ylabel('z');
[X,Z] = meshgrid(vector_x,vector_z);
if strcmp(handles.parameters.mode,'TM')
    val_max_Exz = TM_max_ExEz(X,y0,Z,kx,ky,kt_patrat,beta);
    val_max_Hxz = TM_max_HxHz(X,y0,Z,kx,ky,kt_patrat,omega,epsilon,beta);
    ez = TM_Ez(X,y0,Z,t_crt,kx,ky,omega,beta);
    ex = TM_Ex(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    M_E = sqrt(max(max(ex.^2+ez.^2)));
    scale_E = M_E/val_max_Exz;
    quiver(X,Z,ex,ez,scale_E,'r');
    hx = TM_Hx(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    hz = zeros(size(hx));
    M_H = sqrt(max(max(hx.^2+hz.^2)));
    scale_H = M_H/val_max_Hxz;
    quiver(X,Z,hx,hz,scale_H,'g');
    drawnow;
    hold off;
else
    val_max_Exz = TE_max_ExEz(X,y0,Z,kx,ky,kt_patrat,omega,miu,beta);
    val_max_Hxz = TE_max_HxHz(X,y0,Z,kx,ky,kt_patrat,beta);
    ex = TE_Ex(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    ez = zeros(size(ex));
    M_E = sqrt(max(max(ex.^2+ez.^2)));
    if val_max_Exz > 0
        scale_E = M_E/val_max_Exz;
        quiver(X,Z,ex,ez,scale_E,'r');
    end
    hx = TE_Hx(X,y0,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    hz = TE_Hz(X,y0,Z,t_crt,kx,ky,omega,beta);
    M_H = sqrt(max(max(hx.^2+hz.^2)));
    if val_max_Hxz > 0
        scale_H = M_H/val_max_Hxz;
        quiver(X,Z,hx,hz,scale_H,'g');
    end
    drawnow;
    hold off;
end


function draw_at_one_time_yoz(handles,t_crt,vector_x,vector_y,vector_z,...
    kx,ky,kt_patrat,omega,epsilon,miu,beta)
x0 = handles.parameters.x0;
y0 = handles.parameters.y0;
z0 = handles.parameters.z0;
c = handles.parameters.c;
b = handles.parameters.b;
a = handles.parameters.a;
m = handles.parameters.m;
n = handles.parameters.n;
p = handles.parameters.p;
miu = handles.parameters.mu_r*4*pi*1e-7;
epsilon = handles.parameters.eps_r*1/(36*pi)*1e-9;
v_prim = 1/sqrt(miu*epsilon);
kx = m*pi/a;
ky = n*pi/b;
kt_patrat = kx^2 + ky*2;
beta = p*pi/c;
f_0 = v_prim/2*sqrt((m/a)^2 + (n/b)^2 + (p/c)^2);
omega = 2*pi*f_0;

plot([0 0],[0 c],'b','Linewidth',2);
hold on;
plot([b b],[0 c],'b','Linewidth',2);
plot([0 b],[0 0],'b','Linewidth',2);
plot([0 b],[c c],'b','Linewidth',2);
axis([0 1.1*b 0 1.1*c]);
xlabel('y');
ylabel('z');
[Y,Z] = meshgrid(vector_y,vector_z);
if strcmp(handles.parameters.mode,'TM')
    val_max_Eyz = TM_max_EyEz(x0,Y,Z,kx,ky,kt_patrat,beta);
    val_max_Hyz = TM_max_HyHz(x0,Y,Z,kx,ky,kt_patrat,omega,epsilon,beta);
    ez = TM_Ez(x0,Y,Z,t_crt,kx,ky,omega,beta);
    ey = TM_Ey(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    M_E = sqrt(max(max(ey.^2+ez.^2)));
    scale_E = M_E/val_max_Eyz;
    quiver(Y,Z,ey,ez,scale_E,'r');
    hy = TM_Hy(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta,epsilon);
    hz = zeros(size(hy));
    M_H = sqrt(max(max(hy.^2+hz.^2)));
    scale_H = M_H/val_max_Hyz;
    quiver(Y,Z,hy,hz,scale_H,'g');
    drawnow;
    hold off;
else %TE
    val_max_Eyz = TE_max_EyEz(x0,Y,Z,kx,ky,kt_patrat,omega,miu,beta);
    val_max_Hyz = TE_max_HyHz(x0,Y,Z,kx,ky,kt_patrat,beta);
    ey = TE_Ey(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta,miu);
    ez = zeros(size(ey));
    M_E = sqrt(max(max(ey.^2+ez.^2)));
    scale_E = M_E/val_max_Eyz;
    quiver(Y,Z,ey,ez,scale_E,'r');
    hy = TE_Hy(x0,Y,Z,t_crt,kx,ky,kt_patrat,omega,beta);
    hz = TE_Hz(x0,Y,Z,t_crt,kx,ky,omega,beta);
    M_H = sqrt(max(max(hy.^2+hz.^2)));
    scale_H = M_H/val_max_Hyz;
    quiver(Y,Z,hy,hz,scale_H,'g');
    drawnow;
    hold off;
end

%%%%%%%%%%%%%%%%%%% TM %%%%%%%%%%%%%%%%%%%%
function ex = TM_Ex(x,y,z,t,kx,ky,kt_patrat,omega,beta)
ex = -beta*kx/kt_patrat*cos(kx.*x).*sin(ky.*y).*sin(beta.*z).*sin(omega.*t);

function ey = TM_Ey(x,y,z,t,kx,ky,kt_patrat,omega,beta)
ey = -beta*ky/kt_patrat*sin(kx.*x).*cos(ky.*y).*sin(beta.*z).*sin(omega.*t);

function ez = TM_Ez(x,y,z,t,kx,ky,omega,beta)
ez = sin(kx.*x).*sin(ky.*y).*cos(beta.*z).*sin(omega.*t);

function hx = TM_Hx(x,y,z,t,kx,ky,kt_patrat,omega,beta,epsilon)
hx = omega*epsilon*ky/kt_patrat*sin(kx.*x).*cos(ky.*y).*cos(beta.*z).*cos(omega.*t);

function hy = TM_Hy(x,y,z,t,kx,ky,kt_patrat,omega,beta,epsilon)
hy = -omega*epsilon*kx/kt_patrat*cos(kx.*x).*sin(ky.*y).*cos(beta.*z).*cos(omega.*t);

function val = TM_max_ExEy(x,y,z,kx,ky,kt_patrat,beta)
ex = -beta*kx/kt_patrat*cos(kx.*x).*sin(ky.*y).*sin(beta.*z);
ey = -beta*ky/kt_patrat*sin(kx.*x).*cos(ky.*y).*sin(beta.*z);
val = sqrt(max(max(ex.^2.+ey.^2)));

function val = TM_max_HxHy(x,y,z,kx,ky,kt_patrat,omega,epsilon,beta)
hx = omega*epsilon*ky/kt_patrat*sin(kx.*x).*cos(ky.*y).*cos(beta.*z);
hy = -omega*epsilon*kx/kt_patrat*cos(kx.*x).*sin(ky.*y).*cos(beta.*z);
val = sqrt(max(max(hx.^2.+hy.^2)));

function val = TM_max_EyEz(x,y,z,kx,ky,kt_patrat,beta)
ey = -beta*ky/kt_patrat*sin(kx.*x).*cos(ky.*y).*sin(beta.*z);
ez = sin(kx.*x).*sin(ky.*y).*cos(beta.*z);
val = sqrt(max(max(ey.^2.+ez.^2)));

function val = TM_max_HyHz(x,y,z,kx,ky,kt_patrat,omega,epsilon,beta)
hy = -omega*epsilon*kx/kt_patrat*cos(kx.*x).*sin(ky.*y).*cos(beta.*z);
val = max(max(abs(hy)));

function val = TM_max_ExEz(x,y,z,kx,ky,kt_patrat,beta)
ex = -beta*kx/kt_patrat*cos(kx.*x).*sin(ky.*y).*sin(beta.*z);
ez = sin(kx.*x).*sin(ky.*y).*cos(beta.*z);
val = sqrt(max(max(ex.^2.+ez.^2)));

function val = TM_max_HxHz(x,y,z,kx,ky,kt_patrat,omega,epsilon,beta)
hx = omega*epsilon*ky/kt_patrat*sin(kx.*x).*cos(ky.*y).*cos(beta.*z);
val = max(max(abs(hx)));

%%%%%%%%%%%%%%%%%%% TE %%%%%%%%%%%%%%%%%%%%
function ex = TE_Ex(x,y,z,t,kx,ky,kt_patrat,omega,beta,miu)
ex = omega*miu*ky/kt_patrat*cos(kx.*x).*sin(ky.*y).*sin(beta.*z).*cos(omega.*t);

function ey = TE_Ey(x,y,z,t,kx,ky,kt_patrat,omega,beta,miu)
ey = -omega*miu*kx/kt_patrat*sin(kx.*x).*cos(ky.*y).*sin(beta.*z).*cos(omega.*t);

function hx = TE_Hx(x,y,z,t,kx,ky,kt_patrat,omega,beta)
hx = -beta*kx/kt_patrat*sin(kx.*x).*cos(ky.*y).*cos(beta.*z).*sin(omega.*t);

function hy = TE_Hy(x,y,z,t,kx,ky,kt_patrat,omega,beta)
hy = -beta*ky/kt_patrat*cos(kx.*x).*sin(ky.*y).*cos(beta.*z).*sin(omega.*t);

function hz = TE_Hz(x,y,z,t,kx,ky,omega,beta)
hz = cos(kx.*x).*cos(ky.*y).*sin(beta.*z).*sin(omega.*t);

function val = TE_max_ExEy(x,y,z,kx,ky,kt_patrat,omega,miu,beta)
ex = omega*miu*ky/kt_patrat*cos(kx.*x).*sin(ky.*y).*sin(beta.*z);
ey = -omega*miu*kx/kt_patrat*sin(kx.*x).*cos(ky.*y).*sin(beta.*z);
val = sqrt(max(max(ex.^2.+ey.^2)));

function val = TE_max_HxHy(x,y,z,kx,ky,kt_patrat,beta)
hx = -beta*kx/kt_patrat*sin(kx.*x).*cos(ky.*y).*cos(beta.*z);
hy = -beta*ky/kt_patrat*cos(kx.*x).*sin(ky.*y).*cos(beta.*z);
val = sqrt(max(max(hx.^2.+hy.^2)));

function val = TE_max_ExEz(x,y,z,kx,ky,kt_patrat,omega,miu,beta)
ex = omega*miu*ky/kt_patrat*cos(kx.*x).*sin(ky.*y).*sin(beta.*z);
val = max(max(abs(ex)));

function val = TE_max_HxHz(x,y,z,kx,ky,kt_patrat,beta)
hx = -beta*kx/kt_patrat*sin(kx.*x).*cos(ky.*y).*cos(beta.*z);
hz = cos(kx.*x).*cos(ky.*y).*sin(beta.*z);
val = sqrt(max(max(hx.^2.+hz.^2)));

function val = TE_max_EyEz(x,y,z,kx,ky,kt_patrat,omega,miu,beta)
ey = -omega*miu*kx/kt_patrat*sin(kx.*x).*cos(ky.*y).*sin(beta.*z);
val = max(max(abs(ey)));

function val = TE_max_HyHz(x,y,z,kx,ky,kt_patrat,beta)
hy = -beta*ky/kt_patrat*cos(kx.*x).*sin(ky.*y).*cos(beta.*z);
hz = cos(kx.*x).*cos(ky.*y).*sin(beta.*z);
val = sqrt(max(max(hy.^2.+hz.^2)));